#
# Conditional build:
%bcond_without	tcmalloc	# don't use tcmalloc
#
Summary:	Tools for the XFS filesystem
Summary(pl.UTF-8):	Narzędzia do systemu plików XFS
Name:		xfsprogs
Version:	3.1.11
Release:	2
License:	LGPL v2.1 (libhandle), GPL v2 (the rest)
Group:		Applications/System
Source0:	ftp://linux-xfs.sgi.com/projects/xfs/cmd_tars/%{name}-%{version}.tar.gz
# Source0-md5:	de9f1f45026c2f4e0776058d429ff4b6
Source1:	xfs_lsprojid
Patch0:		%{name}-miscfix-v2.patch
Patch2:		%{name}-sharedlibs.patch
Patch3:		%{name}-pl.po-update.patch
Patch4:		%{name}-dynamic_exe.patch
Patch5:		%{name}-diet.patch
Patch6:		%{name}-repair-tcmalloc.patch
Patch7:		%{name}-noquotasync.patch
URL:		http://www.xfs.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bash
BuildRequires:	gettext-devel
BuildRequires:	libblkid-devel
%{?with_tcmalloc:BuildRequires:	libtcmalloc-devel}
BuildRequires:	libtool
BuildRequires:	libuuid-devel
BuildRequires:	readline-devel
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.402
%{?with_tcmalloc:Requires:	libtcmalloc >= 1.8.3-3}
Obsoletes:	xfsprogs-initrd
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if "%{pld_release}" == "ac"
# libtool in ac doesn't do the reordering of args properly
%define		filterout_ld -Wl,--as-needed
%endif

# libxlog uses symbols from binary that links to libxlog
# libxcmd uses ("program") symbol from binary that links to libxcmd
%define		skip_post_check_so	libxlog.so.0.0.0	libxcmd.so.0.0.0

%define		_sbindir	/sbin
%define		_bindir		/usr/sbin
%define		_libdir		/%{_lib}
%define		_libexecdir	/usr/%{_lib}
# for some reason known only to rpm there must be "\\|" not "\|" here
%define         dietarch        %(echo %{_target_cpu} | sed -e 's/i.86\\|pentium.\\|athlon/i386/;s/amd64/x86_64/;s/armv.*/arm/')
%define         dietlibdir      %{_prefix}/lib/dietlibc/lib-%{dietarch}

%description
A set of commands to use the XFS filesystem, including mkfs.xfs.

XFS is a high performance journaling filesystem which originated on
the SGI IRIX platform. It is completely multi-threaded, can support
large files and large filesystems, extended attributes, variable block
sizes, is extent based, and makes extensive use of Btrees
(directories, extents, free space) to aid both performance and
scalability.

This implementation is on-disk compatible with the IRIX version of
XFS.

%description -l pl.UTF-8
Zbiór komend do użytku z systemem plików XFS, włączając w to mkfs.xfs.

XFS jest wysoko wydajnym systemem plików z kroniką, który oryginalnie
był używany na platformie SGI IRIX. Jest to w pełni wielowątkowy,
obsługujący wielkie pliki oraz wielkie systemy, o rozszerzonych
atrybutach, zmiennych wielkościach bloków, mocno wykorzystujący
B-drzewa by uzyskać wysoką wydajność oraz skalowalność.

%package devel
Summary:	Header files and libraries to develop XFS software
Summary(pl.UTF-8):	Pliki nagłówkowe i biblioteki
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libuuid-devel

%description devel
Header files and libraries to develop software which operates on XFS
filesystems.

%description devel -l pl.UTF-8
Pliki nagłówkowe i biblioteki potrzebne do rozwoju oprogramowania
operującego na systemie plików XFS.

%package static
Summary:	Static XFS software libraries
Summary(pl.UTF-8):	Biblioteki statyczne do XFS
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static XFS software libraries.

%description static -l pl.UTF-8
Biblioteki statyczne do XFS.

%prep
%setup -q
%patch0 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%{?with_tcmalloc:%patch6 -p1}
%patch7 -p1

%build
%{__aclocal} -I m4
%{__autoconf}
%configure \
	--sbindir=%{_bindir}\
	--enable-gettext \
	--enable-readline \
	--enable-blkid \
	DEBUG="%{?debug:-DDEBUG}%{!?debug:-DNDEBUG}" \
	OPTIMIZER="%{rpmcflags}"

%{__make} -j1 \
	V=1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libexecdir},/etc}

DIST_ROOT=$RPM_BUILD_ROOT
DIST_INSTALL=$(pwd)/install.manifest
DIST_INSTALL_DEV=$(pwd)/install-dev.manifest
export DIST_ROOT DIST_INSTALL DIST_INSTALL_DEV

%{__make} install \
	DIST_MANIFEST="$DIST_INSTALL"
%{__make} install-dev \
	DIST_MANIFEST="$DIST_INSTALL_DEV"

install %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/xfs_lsprojid

ln -sf %{_libdir}/$(basename $RPM_BUILD_ROOT%{_libdir}/libhandle.so.*.*.*) \
	 $RPM_BUILD_ROOT%{_libexecdir}/libhandle.so
ln -sf %{_libdir}/$(basename $RPM_BUILD_ROOT%{_libdir}/libxcmd.so.*.*.*) \
	$RPM_BUILD_ROOT%{_libexecdir}/libxcmd.so
ln -sf %{_libdir}/$(basename $RPM_BUILD_ROOT%{_libdir}/libxfs.so.*.*.*) \
	$RPM_BUILD_ROOT%{_libexecdir}/libxfs.so
ln -sf %{_libdir}/$(basename $RPM_BUILD_ROOT%{_libdir}/libxlog.so.*.*.*) \
	$RPM_BUILD_ROOT%{_libexecdir}/libxlog.so

mv $RPM_BUILD_ROOT%{_libdir}/lib*.la $RPM_BUILD_ROOT%{_libexecdir}
mv $RPM_BUILD_ROOT%{_libdir}/lib*.a $RPM_BUILD_ROOT%{_libexecdir}

%{__sed} -i -e "s|libdir='%{_libdir}'|libdir='%{_libexecdir}'|" \
	$RPM_BUILD_ROOT%{_libexecdir}/lib{handle,xcmd,xfs,xlog}.la
%{__sed} -i -e "s| %{_libdir}/libxfs.la | %{_libexecdir}/libxfs.la |" \
	$RPM_BUILD_ROOT%{_libexecdir}/libxlog.la

echo "#10:/mnt/ftp/roman"  >> $RPM_BUILD_ROOT/etc/projects
echo "#ftproman:10" >> $RPM_BUILD_ROOT/etc/projid

%find_lang %{name}

%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}

# already in /usr
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib{handle,xcmd,xfs,xlog}.so

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc README doc/{CHANGES,CREDITS}
%config(noreplace) %verify(not md5 mtime size) /etc/projects
%config(noreplace) %verify(not md5 mtime size) /etc/projid
%attr(755,root,root) %{_sbindir}/fsck.xfs
%attr(755,root,root) %{_sbindir}/mkfs.xfs
%attr(755,root,root) %{_sbindir}/xfs_repair
%attr(755,root,root) %{_bindir}/xfs_*
%attr(755,root,root) %{_libdir}/libhandle.so.*.*
%attr(755,root,root) %{_libdir}/libxcmd.so.*.*
%attr(755,root,root) %{_libdir}/libxfs.so.*.*
%attr(755,root,root) %{_libdir}/libxlog.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libhandle.so.1
%attr(755,root,root) %ghost %{_libdir}/libxcmd.so.0
%attr(755,root,root) %ghost %{_libdir}/libxfs.so.0
%attr(755,root,root) %ghost %{_libdir}/libxlog.so.0
%{_mandir}/man5/projects.5*
%{_mandir}/man5/projid.5*
%{_mandir}/man5/xfs.5*
%{_mandir}/man8/fsck.xfs.8*
%{_mandir}/man8/mkfs.xfs.8*
%{_mandir}/man8/xfs_*.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libexecdir}/libhandle.so
%attr(755,root,root) %{_libexecdir}/libxcmd.so
%attr(755,root,root) %{_libexecdir}/libxfs.so
%attr(755,root,root) %{_libexecdir}/libxlog.so
%{_libexecdir}/libhandle.la
%{_libexecdir}/libxcmd.la
%{_libexecdir}/libxfs.la
%{_libexecdir}/libxlog.la
%{_includedir}/xfs
%{_mandir}/man3/*handle.3*
%{_mandir}/man3/xfsctl.3*

%files static
%defattr(644,root,root,755)
%{_libexecdir}/libhandle.a
%{_libexecdir}/libxcmd.a
%{_libexecdir}/libxfs.a
%{_libexecdir}/libxlog.a
%changelog
* Tue May 14 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xfsprogs.git;a=log;h=master

* Tue May 14 2013 Jan Rękorajski <baggins@pld-linux.org> 7c029ef
- drop initrd stuff
- rel 2

* Fri May 10 2013 Jakub Bogusz <qboosh@pld-linux.org> f8e9104
- updated pl.po-update patch

* Thu May 09 2013 Jakub Bogusz <qboosh@pld-linux.org> adcc007
- force ld.bfd for dietlibc build (gold gets hit by internal error on x86)

* Thu May 09 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 321991e
- md5

* Thu May 09 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> c7b0cba
- up to 3.1.11

* Mon Apr 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> fc42331
- release 2 (by relup.sh)

* Wed Mar 20 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> d74a203
- explanation about 3.4 kernel change

* Fri Dec 14 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> e1a86c1
- up to 3.1.10

* Fri Mar 23 2012 Jakub Bogusz <qboosh@pld-linux.org> 5e4903d
- updated pl.po-update patch (~20 real updates, the rest are caused by regenerated .pot)

* Thu Mar 22 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 4e757d0
- up to 3.1.8; obsolete patches dropped

* Thu Feb 02 2012 Elan Ruusamäe <glen@pld-linux.org> 727e5a6
- fix without tcmalloc deps

* Mon Jan 30 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 0a4251c
- rel 2; don't call expensive quota sync

* Wed Nov 23 2011 Jakub Bogusz <qboosh@pld-linux.org> 4a867e5
- updated pl.po-update patch
- added tcmalloc bcond; updated libtcmalloc BR (now separated from the rest of google-perftools)

* Fri Nov 18 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 4d8d2e7
- force R on google-perftools with some libs in /lib(64)

* Fri Nov 18 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 9988f6a
- up to 3.1.7; po patch merged upstream; add patches: 1) avoid hanging on futexes, 2) lower memory footprint, 3) use libtcmalloc which uses less memory than glibc malloc (which means 5.3GB of ram needed instead of 7.3GB for 7.1TB fs with 95mln inodes).

* Thu Nov 17 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> a32e9a3
- rel 2; simple wrapper for showing project quota id

* Wed Oct 19 2011 Jakub Bogusz <qboosh@pld-linux.org> 8ad4be0
- updated pl.po-update patch

* Sat Oct 15 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 1d010a3
- up to 3.1.6

* Sat Jul 23 2011 areq <areq@pld-linux.org> 0efa133
- typo

* Mon Jul 11 2011 Paweł Gołaszewski <blues@pld-linux.org> 6e781c1
- rel.3 - add project config files

